
def newton_solve(f, df, x0, maxit=50, epsilon=1e-8):
	''' skal løse ligningen f(x) = 0, for hvilken som helst glatt funksjon f(x).
	Dette gjøres ved at funksjonen regner ut f(x), og sjekker om dette blir 0, med en toleranse.
	Hvis dette stemmer, returneres x-verdien. Hvis ikke, oppdateres verdien for x ved ligning oppgitt i oppgaveteksten.
	Slik vil x-verdien nærme seg mer og mer den verdien for x som gir f(x) = 0.
	Dette bør gjøres i en løkke! Pass på:
	- x-verdien må oppdateres hver gang i løkken
	- programmet må ha telling på hvor mange ganger x-verdien er blitt oppdatert, ettersom du må bruke raise f.eks IndexError om maxit er nådd
	- hvis df(x) = 0 for den x-verdien som skal testes, vil newtons metode ikke føre frem. Derfor skal du for hver nye x, sjekke at 
		df(x) ikke blir 0. Hvis den blir det, skal du kaste VauleError

	Debugging:
	- PRINT UT MASSE. Se om x-verdien faktisk endrer seg for hver gang i løkken. Sjekk at f(x) går mer og mer mot 0.		
	'''

def finn_konsentrasjon(s, K_AlH, K_HCa, K_H):
	''' skal løse f(x) = 0 der funksjonen er den oppgitt i oppgaveteksten, ligning 3.1.
	Funksjonen skal kunne brukes til både reservoar A og B, ettersom alle likevektskonstantene tas inn som argument.
	- Tips til f(x) og df(x): funksjon inni funksjon er ikke noe problem! 
		Lambda-funksjoner er å anbefale, de er veldig kompakte og fine.
		Husk: parameterene du sender inn i funksjonen vil være definerte inni eventuelle "indre funksjoner" også!
	- du skal ha et startgjett for x som du finner i programmet i plot_concentrations.py
	- du skal finne konsentrasjonen ved å kalle på newton_solve i finn_konsentrasjon
	- husk ValueError hvis x blir negativ (negativ konsentrasjon gir ikke mening)

	Debugging:
	- Trippelsjekk at f(x) og df(x) er skrevet riktig
	- Skriv ned den deriverte df/dx på papir før du skriver funksjonen inn i programmet
	'''


def read_file(filename):
	''' skal kunne lese hvilken som helst fil fra birkenes. Dette betyr at filnavnet MÅ være et parameter.
	Merkelappene øverst i filen kan derfor variere, og skal hentes ut av filen. Du skal returnere en dictionary, 
	som beskrevet i oppgaveteksten.

	En viktig forskjell mellom lister og dictionaries:
	Når du looper gjennom en liste, vil dette se omtrent slik ut: '''
	for element in my_list:
		print(element)
	# Hvis my_list og andre lister skal inn i en dictionary gjøres dette slik:
	my_dict = {'tag_1': my_list, 'tag_2': my_other_list, 'tag_3': my_last_list}
	# Hvis jeg nå skal printe ut alle elementene i listene, vil dette gjøres slik:
	for tag in my_dict:
		current_list = my_dict[tag]
		for element in current_list:
			print(element)
	'''
	Tips:
	- print ut variabler inni funksjonen for å se om funksjonen gjør det du forventer at den skal gjøre. 
	- husk at alt som kommer inn fra filen er String! Dette må dere endre for alle tallene.
	- filen må opnes og lukkes INNI funksjonen.
	'''